<div class="mx-1">
<div *ngIf="inputVisible">
    <form [ngSwitch]="getTypeName()" (ngSubmit)="submitted()">
        <input *ngSwitchCase="'number'" type="number"
            (blur)="onBlur()"
            (keyup)="$event.stopPropagation(); onKeyUp($event)"
            (keydown)="$event.stopPropagation();"
            (click)="$event.stopPropagation();"
            (change)="changed()"
            [(ngModel)]="changedValue"
            [class.error]="!isValueValid()"
            name="changedValue"
            id="changedValue"
            class="mat-raised-button mat-button-base mat-primary"
            step="0.01"
            #valueInput/>
        <input *ngSwitchDefault type="string"
            (blur)="onBlur()"
            (keyup)="$event.stopPropagation(); onKeyUp($event)"
            (keydown)="$event.stopPropagation();"
            (click)="$event.stopPropagation();"
            (change)="changed()"
            [(ngModel)]="changedValue"
            [class.error]="!isValueValid()"
            name="changedValue"
            id="changedValue"
            class="mat-raised-button mat-button-base mat-primary"
            step="0.01"
            #valueInput/>
    </form>
</div>
<div *ngIf="!inputVisible"
     (click)="$event.stopPropagation(); onClicked()"
     [ngSwitch]="getTypeName()"
     class="shown-value rounded-md px-2 border-b">
    <span *ngSwitchCase="'number'">{{ changedValue | number: format }}</span>
    <span fxFlex="auto" *ngSwitchDefault>{{ changedValue }}</span>
</div>
</div>